import torch
from torch import nn


class NSELoss(torch.nn.Module):
    __name__ = "NSE"

    def __init__(self):
        super(NSELoss, self).__init__()

    def forward(self, output, target):

        if len(target.shape) == 2:
            target = target[:,:,None]

        if len(output.shape) == 2:
            output = output[:,:,None]

        Ngage = target.shape[1]
        losssum = 0
        nsample = 0
        for ii in range(Ngage):
            p0 = output[:, ii, 0]
            t0 = target[:, ii, 0]
            mask = t0 == t0
            if len(mask[mask == True]) > 0:
                p = p0[mask]
                t = t0[mask]
                tmean = t.mean()
                SST = torch.sum((t - tmean) ** 2)
                if SST != 0:
                    SSRes = torch.sum((t - p) ** 2)
                    temp = 1 - SSRes / SST
                    losssum = losssum + temp
                    nsample = nsample + 1
        # minimize the opposite average NSE
        loss = -(losssum / nsample)
        return loss
