import torch
from torch import nn


# class RMSELoss(nn.Module):
#     __name__ = "RMSE"
#     def __init__(self):
#         super(RMSELoss, self).__init__()
#         self.mse = nn.MSELoss()
# 
#     def forward(self, y_pr, y_gt, time_dim=None):
#         """
#         RMSELoss()(y_pr, y_gt)
#         RMSELoss()(y_pr, y_gt, basins_dim = 0)
# 
#         If you want to calculate the loss for each basin, set time_dim = 0 or other number
#         y_pr size: basins, times, 1
#         y_gt size: basins, times, 1
#         output loss size: basins
# 
#         """
#         if len(y_gt.shape) == 2:
#             y_gt = y_gt[:,:,None]
#         if len(y_pr.shape) == 2:
#             y_pr = y_pr[:,:,None]
# 
#         eps = 1e6
#         if time_dim is None:
#             y_pr = y_pr.flatten()
#             y_gt = y_gt.flatten()
# 
#             mse = torch.nanmean( (y_pr-y_gt)**2)
#             loss = torch.sqrt(mse+eps)
#         else:
#             mse = torch.nanmean((y_pr - y_gt) ** 2, dim=time_dim)
#             loss = torch.sqrt(mse+eps)
#             loss = torch.squeeze(loss)
#         return loss

class RMSELoss(torch.nn.Module):
    __name__ = "RMSE"
    def __init__(self):
        super(RMSELoss, self).__init__()

    def forward(self, output, target):

        if len(target.shape) == 2:
            target = target[:,:,None]
        ny = target.shape[2]
        loss = 0
        for k in range(ny):
            p0 = output[:, :, k]
            t0 = target[:, :, k]
            mask = t0 == t0
            p = p0[mask]
            t = t0[mask]
            temp = torch.sqrt(((p - t) ** 2).mean())
            loss = loss + temp
        return loss